package cn.ibizlab.assetmanagement.core.workorder.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.assetmanagement.core.workorder.domain.EAMWOStateModel;
import cn.ibizlab.assetmanagement.core.workorder.filter.EAMWOStateModelSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EAMWOStateModel] 服务对象接口
 */
public interface IEAMWOStateModelService extends IService<EAMWOStateModel>{

    boolean create(EAMWOStateModel et) ;
    void createBatch(List<EAMWOStateModel> list) ;
    boolean update(EAMWOStateModel et) ;
    void updateBatch(List<EAMWOStateModel> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EAMWOStateModel get(String key) ;
    EAMWOStateModel getDraft(EAMWOStateModel et) ;
    boolean checkKey(EAMWOStateModel et) ;
    boolean save(EAMWOStateModel et) ;
    void saveBatch(List<EAMWOStateModel> list) ;
    Page<EAMWOStateModel> searchDefault(EAMWOStateModelSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EAMWOStateModel> getEamwostatemodelByIds(List<String> ids) ;
    List<EAMWOStateModel> getEamwostatemodelByEntities(List<EAMWOStateModel> entities) ;
}


